/*
	KUMAamp project()
	Copyright (C) Mamiya 2000.
	License:GPL
	---------------------------------------------------------------------------
	GYM sub
	gym.c
*/

#include "in_mdx.h"

/* ANSI/Windows standard headers */
#include <windows.h>

/* Libraries headers */
#if USE_ZLIB
#include <zlib.h>
#endif

/* Project headers */
#include "gym.h"

#define GYM_MAGIC 0x584d5947	/* 'GYMX' */

static char tempgym[MAX_PATH] = "";

void gymclean(void)
{
	if (tempgym[0] != '\0')
	{
		DeleteFile(tempgym);
		tempgym[0] = '\0';
	}
}

static char *LoadFile(char *fn, LPDWORD lpdwSize)
{
	HANDLE hFile = INVALID_HANDLE_VALUE;
	char *ret = NULL;
	char *buf = NULL;
	do
	{
		DWORD len;
		hFile = CreateFile(
			fn,
			GENERIC_READ,
			FILE_SHARE_READ,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_ARCHIVE |
			FILE_ATTRIBUTE_COMPRESSED |
			FILE_ATTRIBUTE_HIDDEN |
			FILE_ATTRIBUTE_OFFLINE |
			FILE_ATTRIBUTE_READONLY |
			FILE_ATTRIBUTE_SYSTEM |
			FILE_ATTRIBUTE_TEMPORARY |
			FILE_FLAG_SEQUENTIAL_SCAN,
			NULL);
		if (hFile == INVALID_HANDLE_VALUE) break;
		len = GetFileSize(hFile, NULL);
		if (len == 0xFFFFFFFF) break;
		buf = (char *)malloc(len);
		if (buf == NULL) break;
		if (!ReadFile(hFile, buf, len, lpdwSize, NULL)) break;
		if (len != *lpdwSize) break;
		ret = buf;
		buf = NULL;
	} while (0);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);
	if (buf != NULL) free(buf);
	return ret;
}
#define freefile(p) { if (p != NULL) free(p); }

static int GetDwordLE(char *p)
{
	int ret;
	ret  = ((int)(unsigned char)p[3]) << 0x18;
	ret |= ((int)(unsigned char)p[2]) << 0x10;
	ret |= ((int)(unsigned char)p[1]) << 0x08;
	ret |= ((int)(unsigned char)p[0]) << 0x00;
	return ret;
}

void GetTitleGYM(char *fn, char *title)
{
	HANDLE hFile = CreateFile(
		fn,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_ARCHIVE |
		FILE_ATTRIBUTE_COMPRESSED |
		FILE_ATTRIBUTE_HIDDEN |
		FILE_ATTRIBUTE_OFFLINE |
		FILE_ATTRIBUTE_READONLY |
		FILE_ATTRIBUTE_SYSTEM |
		FILE_ATTRIBUTE_TEMPORARY,
		NULL);
	if (hFile != INVALID_HANDLE_VALUE)
	{
		DWORD i, len = 0;
		int id = 0;
		char buf[32], *p = title;
		if (ReadFile(hFile, buf, 4, &len, NULL) && len == 4 && GetDwordLE(buf) == GYM_MAGIC)
		{
			SetFilePointer(hFile, 4 + 32, NULL, FILE_BEGIN);
			if (ReadFile(hFile, buf, sizeof(buf), &len, NULL) && buf[0] != '\x00')
			{
				for (i = 0; i < len; i++)
				{
					if (buf[i] == '\x00') break;
					*(p++) = buf[i];
				}
			}
			SetFilePointer(hFile, 4, NULL, FILE_BEGIN);
			if (ReadFile(hFile, buf, sizeof(buf), &len, NULL) && buf[0] != '\x00')
			{
				if (p != title) *(p++) = ' ';
				*(p++) = '[';
				*(p++) = ' ';
				for (i = 0; i < len; i++)
				{
					if (buf[i] == '\x00') break;
					*(p++) = buf[i];
				}
				*(p++) = ' ';
				*(p++) = ']';
			}
			*p = '\0';
			CloseHandle(hFile);
		}
	}
}

char *gyminflate(char *infile)
{
#if !USE_ZLIB
	return infile;
#else
	char *gymbuf = NULL, *outbuf = NULL;
	char *ret = infile;
	do
	{
		HANDLE hTemp = INVALID_HANDLE_VALUE;
		char temppath[MAX_PATH], *sp;
		DWORD gymsize, outsize;
		int i, compsize;

		gymbuf = LoadFile(infile, &gymsize);
		if (gymbuf == NULL) break;
		if (gymsize >= 4 && GetDwordLE(gymbuf) != GYM_MAGIC) break;

		compsize = GetDwordLE(gymbuf + 4 + 32 * 5 + 256 + 4);
		sp = gymbuf + (4 + 32 * 5 + 256 + 4 + 4);
		gymsize -= (4 + 32 * 5 + 256 + 4 + 4);

		if (compsize)
		{
			outsize = compsize;
		}
		else
		{
			outsize = gymsize;
		}

		outbuf = malloc(outsize);
		if (outbuf == NULL) break;

		if (compsize)
		{
			if (Z_OK != uncompress(outbuf, &outsize, sp, gymsize)) break;
		}
		else
			CopyMemory(outbuf, sp, gymsize);

		GetTempPath(MAX_PATH, temppath);
		for (i = 1; hTemp == INVALID_HANDLE_VALUE; i++)
		{
			wsprintf(tempgym, "%stmp_%d.gym",temppath, i);
			hTemp = CreateFile(
				tempgym,
				GENERIC_READ | GENERIC_WRITE,
				FILE_SHARE_READ | FILE_SHARE_WRITE/* | FILE_SHARE_DELETE*/,
				NULL,
				CREATE_NEW,
				FILE_ATTRIBUTE_NORMAL/* | FILE_FLAG_DELETE_ON_CLOSE*/,
				NULL
			);
		}
		if (hTemp != INVALID_HANDLE_VALUE)
		{
			WriteFile(hTemp, outbuf, outsize, &gymsize, NULL);
			CloseHandle(hTemp);
			ret = tempgym;
		}
		else
		{
			tempgym[0] = '\0';
		}
	} while(0);

	freefile(gymbuf);
	freefile(outbuf);
	return ret;
#endif
}
